package com.bocloud.sms.entity;

import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreAll;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.GenericEntity;
import com.bocloud.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * 业务实体类
 *
 * @author wangyu
 * @version 4.1.0-SNAPSHOT
 * @since 2018/12/24
 */
@Table("business")
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
public class Business extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column("code")
    private String code;
    @IgnoreAll
    private Integer projectNum;
    @IgnoreAll
    private String projects;
    @IgnoreAll
    private List<Long> projectIds;
    @Column("tenant_id")
    private Long tenantId;

    /**
     * 业务类型
     */
    @Column("business_type")
    private String businessType;

//    @Column("department_id")
//    private Long departmentId;

    @IgnoreAll
    private String departmentName;

    /**
     * 系统负责人id
     */
    @IgnoreAll
    private Long systemId;

    /**
     * 运维负责人id
     */
    @IgnoreAll
    private Long preserveId;

    /**
     * 系统负责人
     */
    @IgnoreAll
    private String systemName;

    /**
     * 运维负责人
     */
    @IgnoreAll
    private String preserveName;

    @IgnoreAll
    private Long projectId;

    @IgnoreAll
    private String ownerName;

    @IgnoreAll
    private String menderName;

    @IgnoreAll
    private String businessName;

    /**
     * 团队
     */
    @IgnoreAll
    private String projectName;

    public Business(Long id, String code, Integer projectNum, Long tenantId) {
        this.id = id;
        this.code = code;
        this.projectNum = projectNum;
        this.tenantId = tenantId;
    }



    public enum BusinessType {

        /**
         * 交易类
         */
        Transaction,

        /**
         * 办公类
         */
        Office,

        /**
         * 测试类
         */
        Test

    }
}
