package com.bocloud.sms.entity;

import com.bocloud.common.model.RequestContext.Catalog;
import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreAll;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.GenericEntity;
import com.bocloud.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

/**
 * 消息类
 *
 * @author weiwei
 * @version 1.0
 * @since 2016.10.26
 */
@Table("message")
@Data
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
public class Message extends GenericEntity {
    /**
     * id
     */
    @PK(value = PKStrategy.AUTO)
    private Long id;
    /**
     * 消息内容
     */
    @Column("content")
    private String content;
    /**
     * 发送者
     */
    @Column("sender")
    private Long sender;
    /**
     * 账号类型
     */
    @Column("catalog")
    private Catalog catalog;
    /**
     * 发送者名称
     */
    @IgnoreAll
    private String senderName;
    /**
     * 已读数量
     */
    @IgnoreAll
    private BigDecimal readCount;
    /**
     * 未读数量
     */
    @IgnoreAll
    private BigDecimal unreadCount;
    /**
     * 总计
     */
    @IgnoreAll
    private Long total;

}
