package com.bocloud.sms.entity;

import com.bocloud.common.utils.DateSerializer;
import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreUpdate;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.Generic;
import com.bocloud.entity.meta.PKStrategy;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 插件表
 *
 * @author fanzx
 * @version 5.6.0-SNAPSHOT
 * @since 2022/2/16
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("plugins")
public class Plugins extends Generic {

    /**
     * 唯一ID
     */
    @PK(PKStrategy.AUTO)
    private Long id;

    /**
     * 插件名称
     */
    @Column("name")
    private String name;

    /**
     * 插件编码
     */
    @Column("code")
    private String code;

    /**
     * 插件平台类型
     */
    @Column("vendor_type")
    private String vendorType;

    /**
     * 插件描述
     */
    @Column("remark")
    private String remark;

    /**
     * 是否删除
     */
    @Column("is_deleted")
    private Boolean isDeleted;

    /**
     * 插件状态true开启/false关闭
     */
    @Column("status")
    private Boolean status;

    /**
     * 创建时间
     */
    @Column("gmt_create")
    @IgnoreUpdate
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtCreate;

    /**
     * 修改时间
     */
    @Column("gmt_modify")
    @IgnoreUpdate
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtModify;

    public Plugins(String code, Boolean status) {
        this.code = code;
        this.status = status;
    }

    public Plugins(String code) {
        this.code = code;
    }
}
