package com.bocloud.sms.interfaces;

import com.bocloud.common.exception.InternalServerException;
import com.bocloud.common.model.*;
import com.bocloud.sms.entity.Admission;
import com.bocloud.sms.model.AdmissionModel;

import java.util.List;

/**
 * ip访问控制业务接口
 *
 * @author wangyu
 * @version 4.2.1-SNAPSHOT
 * @since 2019/11/12
 */
public interface AdmissionService {

    /**
     * 查询IP访问限制列表
     *
     * @param pager
     * @return
     */
    BocloudResult<GridBean<Admission>> list(Pager pager);

    /**
     * 查询IP访问限制详情
     *
     * @param id
     * @return
     */
    BocloudResult<Admission> detail(Long id);

    /**
     * 创建IP访问限制
     *
     * @param admission
     * @param requestContext
     * @return
     * @throws InternalServerException
     */
    Result create(AdmissionModel admission, RequestContext requestContext) throws InternalServerException;

    /**
     * 删除IP访问限制
     *
     * @param id
     * @return
     * @throws InternalServerException
     */
    Result remove(Long id) throws InternalServerException;

    /**
     * 批量删除IP访问限制
     *
     * @param ids
     * @return
     * @throws InternalServerException
     */
    Result batchRemove(List<Long> ids) throws InternalServerException;
}
