package com.bocloud.sms.interfaces;


import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.model.Result;
import com.bocloud.sms.entity.Dictionary;
import com.bocloud.sms.model.DictionaryBean;

import java.util.List;
import java.util.Map;

/**
 * 环境信息服务接口
 *
 * @author dmw
 */
public interface DictService {

    /**
     * 保存
     *
     * @param dictionary
     * @return
     */
    BocloudResult<Dictionary> create(Dictionary dictionary);

    /**
     * 删除
     *
     * @param id
     * @return
     */
    Result remove(Long id);

    /**
     * 修改
     *
     * @param bean
     * @return
     */
    BocloudResult<Dictionary> modify(DictionaryBean bean);

    /**
     * 字典树
     *
     * @param pid
     * @return
     */
    BocloudResult<List<Dictionary>> list(Long pid);

    /**
     * 根据值获取子节点数据
     *
     * @param pid
     * @return
     */
    BocloudResult<List<Dictionary>> listChild(String pid);

    /**
     * 查询字典树
     *
     * @param pid
     * @return
     */
    BocloudResult<List<Dictionary>> childTree(String pid);

}
