package com.bocloud.sms.interfaces;

import com.bocloud.common.model.*;
import com.bocloud.sms.entity.SystemTask;

/**
 * @author tyl
 * @since 2021/4/1 17:27
 */
public interface SystemTaskService {

    /**
     * 查询平台任务列表
     *
     * @param pager
     * @return
     */
    BocloudResult<GridBean<SystemTask>> list(Pager pager);

    /**
     * 创建平台任务
     *
     * @param systemTask
     * @param context
     * @return
     */
    Result create(SystemTask systemTask, RequestContext context);

    /**
     * 删除平台任务
     *
     * @param id
     * @param context
     * @return
     */
    Result remove(Long id,RequestContext context);

    /**
     * 修改平台任务
     *
     * @param id
     * @param systemTask
     * @param context
     * @return
     */
    Result modify(Long id,SystemTask systemTask, RequestContext context);

    /**
     * 查询平台任务详情
     *
     * @param id
     * @return
     */
    BocloudResult<SystemTask> detail(Long id);

}
