package com.bocloud.sms.repository;


import com.bocloud.common.utils.MapTools;
import com.bocloud.database.core.intf.impl.BasicGenericDao;
import com.bocloud.sms.entity.CloudService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;


/**
 *服务
 *
 * @author hya
 * @since 2022-03-02
 */
@Repository
public class CloudServiceRepository extends BasicGenericDao<CloudService, Long> {

    @Autowired
    public CloudServiceRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate) {
        super(jdbcTemplate, npJdbcTemplate);
    }

    /**
     * 根据 roleId 查询服务
     *
     * @param roleId
     * @return
     */
    public List<CloudService> listRoleServices(Long roleId) {
        String sql = "select a.*,i.icon icon, c.`name` catalog_name from cloud_service a " +
                "left join icon i on a.icon_id = i.id left join service_catalog c on a.catalog_id = c.id " +
                "left join service_role rs on a.id = rs.service_id where rs.role_id=:roleId";
        Map<String, Object> params = MapTools.simpleMap("roleId", roleId);
        return super.list(CloudService.class,sql,params);
    }
}
