package com.bocloud.sms.repository;

import com.bocloud.common.exception.BoCloudDBException;
import com.bocloud.database.core.intf.impl.BasicGenericDao;
import com.bocloud.sms.model.ServiceInvokeModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @Author hya
 * @Date 2022/3/21 11:24
 */
@Repository
public class ServiceInvokeModelRepository extends BasicGenericDao<ServiceInvokeModel, Long> {
    @Autowired
    public ServiceInvokeModelRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate) {
        super(jdbcTemplate, npJdbcTemplate);
    }

    /**
     * 获取服务调用次数
     *
     * @return
     * @throws Exception
     */
    public List<ServiceInvokeModel> statistics() throws BoCloudDBException {
        String sql = "select request_module source, module target, count(*) count from access_log where request_module is not null group by request_module, module";
        return  super.list(ServiceInvokeModel.class, sql);
    }


}
